﻿Imports System.Runtime.CompilerServices

Namespace System.Windows.Forms

   Public Module TextboxBaseX
      Private Const WM_HSCROLL As Int32 = &H114
      Private Const WM_VSCROLL As Int32 = &H115

      Private Const SB_TOP As Int32 = 6
      Private Const SB_LEFT As Int32 = 6
      Private Const SB_BOTTOM As Int32 = 7
      Private Const SB_RIGHT As Int32 = 7

      Private Declare Auto Function SendMessage Lib "user32.dll" ( _
          ByVal hwnd As IntPtr, _
          ByVal wMsg As Int32, _
          ByVal wParam As Int32, _
          ByVal lParam As IntPtr _
      ) As IntPtr

      <Extension()> _
      Public Sub ScrollToFirst(ByVal TextBox As TextBoxBase, ByVal direction As Orientation)
         SendMessage(TextBox.Handle, WM_HSCROLL + direction, SB_TOP, IntPtr.Zero)
      End Sub

      <Extension()> _
      Public Sub ScrollToLast(ByVal TextBox As TextBoxBase, ByVal direction As Orientation)
         SendMessage(TextBox.Handle, WM_HSCROLL + direction, SB_BOTTOM, IntPtr.Zero)
      End Sub

      <Extension()> _
      Public Function AppendLine(Of T As TextBoxBase)(ByVal subj As T, ByVal ParamArray args As Object()) As T
         subj.AppendText(String.Concat(args) & Environment.NewLine)
         Return subj
      End Function

   End Module

End Namespace