﻿Imports System.Runtime.CompilerServices

Namespace System.Collections.Generic

   Public Class Initer
      Public Shared Function From(Of Ta, Tb, Tc, Td, Te, Tf)(ByVal a As Ta, ByVal b As Tb, ByVal c As Tc, ByVal d As Td, ByVal e As Te, ByVal f As Tf) As Initer(Of Ta, Tb, Tc, Td, Te, Tf)
         Return (New Initer(Of Ta, Tb, Tc, Td, Te, Tf))(a, b, c, d, e, f)
      End Function
      Public Shared Function From(Of Ta, Tb, Tc, Td, Te)(ByVal a As Ta, ByVal b As Tb, ByVal c As Tc, ByVal d As Td, ByVal e As Te) As Initer(Of Ta, Tb, Tc, Td, Te)
         Return (New Initer(Of Ta, Tb, Tc, Td, Te))(a, b, c, d, e)
      End Function
      Public Shared Function From(Of Ta, Tb, Tc, Td)(ByVal a As Ta, ByVal b As Tb, ByVal c As Tc, ByVal d As Td) As Initer(Of Ta, Tb, Tc, Td)
         Return (New Initer(Of Ta, Tb, Tc, Td))(a, b, c, d)
      End Function
      Public Shared Function From(Of Ta, Tb, Tc)(ByVal a As Ta, ByVal b As Tb, ByVal c As Tc) As Initer(Of Ta, Tb, Tc)
         Return (New Initer(Of Ta, Tb, Tc))(a, b, c)
      End Function
      Public Shared Function From(Of Ta, Tb)(ByVal a As Ta, ByVal b As Tb) As Initer(Of Ta, Tb)
         Return (New Initer(Of Ta, Tb))(a, b)
      End Function
   End Class

   Public Class Initer(Of Ta, Tb, Tc, Td, Te, Tf) : Inherits List(Of [Set](Of Ta, Tb, Tc, Td, Te, Tf))
      Default Public Shadows ReadOnly Property Adding(ByVal a As Ta, ByVal b As Tb, ByVal c As Tc, ByVal d As Td, ByVal e As Te, ByVal f As Tf) As Initer(Of Ta, Tb, Tc, Td, Te, Tf)
         Get
            MyBase.Add(NewSet(a, b, c, d, e, f))
            Return Me
         End Get
      End Property
   End Class
   Public Class Initer(Of Ta, Tb, Tc, Td, Te) : Inherits List(Of [Set](Of Ta, Tb, Tc, Td, Te))
      Default Public Shadows ReadOnly Property Adding(ByVal a As Ta, ByVal b As Tb, ByVal c As Tc, ByVal d As Td, ByVal e As Te) As Initer(Of Ta, Tb, Tc, Td, Te)
         Get
            MyBase.Add(NewSet(a, b, c, d, e))
            Return Me
         End Get
      End Property
   End Class
   Public Class Initer(Of Ta, Tb, Tc, Td) : Inherits List(Of [Set](Of Ta, Tb, Tc, Td))
      Default Public Shadows ReadOnly Property Adding(ByVal a As Ta, ByVal b As Tb, ByVal c As Tc, ByVal d As Td) As Initer(Of Ta, Tb, Tc, Td)
         Get
            MyBase.Add(NewSet(a, b, c, d))
            Return Me
         End Get
      End Property
   End Class
   Public Class Initer(Of Ta, Tb, Tc) : Inherits List(Of [Set](Of Ta, Tb, Tc))
      Default Public Shadows ReadOnly Property Adding(ByVal a As Ta, ByVal b As Tb, ByVal c As Tc) As Initer(Of Ta, Tb, Tc)
         Get
            MyBase.Add(NewSet(a, b, c))
            Return Me
         End Get
      End Property
   End Class
   Public Class Initer(Of Ta, Tb) : Inherits List(Of [Set](Of Ta, Tb))
      Default Public Shadows ReadOnly Property Adding(ByVal a As Ta, ByVal b As Tb) As Initer(Of Ta, Tb)
         Get
            MyBase.Add(NewSet(a, b))
            Return Me
         End Get
      End Property
      Public Overloads Function ToArray(Of T)(ByVal converter As Func(Of [Set](Of Ta, Tb), T)) As T()
         Dim res(Count - 1) As T
         For i = 0 To Count - 1
            res(i) = converter(MyBase.Item(i))
         Next
         Return res
      End Function
   End Class
End Namespace


